#! /bin/bash

# The first command specify how to run something
runcmd="$1"

i=0
declare -a inits
declare -a crashes
declare -a rands
while read -r value rand c; do
    inits[$i]=$value
    crashes[$i]=$c
    rands[$i]=$rand
    i=$((i+1))
done < config.txt

j=0
declare -a pids
while read p; do
    echo "Bringing up server [$j]..."
    touch "log_server_$j.log"
    ${runcmd} "$j" ${inits[$j]} ${rands[$j]} ${crashes[$j]} > "log_server_$j.log" &
    pids[$j]="$!"
    sleep 2 # Sleep for a little bit to wait
    j=$((j+1))
done < addresses.txt

echo "All servers up."

k=0
while read p; do
    echo "Waiting for server [$k]"
    wait ${pids[$k]}
    echo "Server [$k] terminates."
    k=$((k+1))
done < addresses.txt
